<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/svg-inject.min.js"></script>
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <script src="{basePath}/common.js"></script>
    <script src="{basePath}/konva.min.js"></script>
    <script src="{basePath}/vakata-jstree-6dce227/dist/jstree.min.js"></script>

    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
    <link rel="stylesheet" href="{basePath}/common.css">
    <link rel="stylesheet" href="{basePath}/indexDark.css">
    <link rel="stylesheet" href="{basePath}/vakata-jstree-6dce227/dist/themes/quantr/style.min.css">
</head>

<body>
    <div id="loadingDiv">
        <img src="{basePath}/../../resources/dark/loading.svg" style="stroke: white;" />
    </div>
    <div class="container-fluid">
        <div class="row">
            <div class="col" id="toolbar">
                <form class="form-inline">
                    Block width
                    <input id="blockWidth" class="form-control" type="text" style="width: 50px;" value="12" /> From
                    <input class="form-control" type="text" /> To
                    <input class="form-control" type="text" /> Search
                    <input class="form-control" type="text" />
                    <button type="button" class="btn btn-primary" onClick="initKonva();">Go</button> Move :
                    <select class="form-control">
                        <option>Rising Edge</option>
                        <option>Falling Edge</option>
                    </select>
                    <button type="button" class="btn btn-primary" onClick="">&lt;</button>
                    <button type="button" class="btn btn-primary" onClick="">&gt;</button>
                </form>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <div id="jstree"></div>
            </div>
            <div class="col">
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div id="container"></div>
            </div>
        </div>
    </div>
    <!-- <canvas id="myCanvas" width="200" height="100"></canvas>
    <script>
        var c = document.getElementById("myCanvas");
        var ctx = c.getContext("2d");
        ctx.moveTo(0, 0);
        ctx.lineTo(200, 100);
        ctx.stroke();

        var img = new Image();
        img.onload = function() {
            ctx.drawImage(img, 0, 0);
        }
        img.src = "{basePath}/../../resources/dark/cpu2.svg";
    </script> -->
    <div id="mainDiv" style="display: none;">
        <table id=" mainTable" class="table table-dark table-striped">
            <thead></thead>
            <tbody></tbody>
        </table>
    </div>
    <div id="debug"></div>
    <pre id="mainDivXml"></pre>
    <script>
        var referenceToWireRowId = {};
        var wires = {};
        var wiresValue = {};
        var wiresValues = {};
        var wiresNameToReference = {};
        var wireSize = {};
        var treeScopes;

        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
                case 'update':
                    //$('#mainDivXml').html(escapeHTML(message.text));
                    try {
                        $('#loadingDiv').append('<br>loading vcd file, length=' + message.text.length);
                        vcd = JSON.parse(message.text);
                        $('#mainTable tbody').html('');
                        referenceToWireRowId = {};
                        wiresValue = {};
                        treeScope = [];

                        $('#loadingDiv').append('<br>loading scope');
                        loadScope(vcd.scope, 0, '#');
                        console.log('2 ' + new Date());

                        //loadData(vcd.data);
                        //initTree();

                        // console.log(message.text.length);
                        //loadXML(message.text);

                        $('#loadingDiv').append('<br>SVGInject');
                        SVGInject(document.querySelectorAll("img"));
                        console.log('3 ' + new Date());

                        initKonva();
                        console.log('4 ' + new Date());

                        $('#loadingDiv').css('display', 'none');
                    } catch (e) {
                        $('#debug').append('error : ' + e);
                    }
                    break;
            }
        });

        function log(str) {
            $('#debug').append(str + "<br>");
        }

        function loadScope(scope, indent, parentTreeNode) {
            console.log('loadScope ' + scope + ', wires.length=' + scope.wires.length);
            $('#mainTable tbody').append("<tr><td class='wireHeaderTd' style='padding-left: " + (indent + 1) * 20 + "px;'>" + '<img src="{basePath}/../../resources/dark/cpu.svg" style="fill: #00aaaa !important; height: 20px;" /> ' + scope.name + "</td></tr>");
            for (let w = 0; w < scope.wires.length; w++) {
                let wire = scope.wires[w];
                let rowNo = $('#mainTable tbody').find('tr').length;
                let wireId = "wire" + rowNo;
                if (referenceToWireRowId[wire.reference] == null) {
                    referenceToWireRowId[wire.reference] = [];
                }
                referenceToWireRowId[wire.reference].push(wireId);
                wireSize[wire.reference] = wire.size;
                wiresValue[wire.reference] = 0;
                wiresValues[wire.reference] = [];
                wiresNameToReference[wire.name] = wire.reference;

                if (wires[wire.name] == null) {
                    wires[wire.name] = wire;
                }
                $('#mainTable tbody').append("<tr id='" + wireId + "'><td class='wireHeaderTd' style='padding-left: " + (indent + 1) * 20 + "px;'>" + '<img src="{basePath}/../../resources/dark/cpu2.svg" style="fill: #00aa00 !important; height: 20px;" /> ' + wire.name + "</td></tr>");
            }
            treeScope.push({
                "id": scope.name,
                "parent": parentTreeNode,
                "text": scope.name,
                'state': {
                    'opened': true
                },
                "wires": scope.wires
            });
            for (let x = 0; x < scope.scopes.length; x++) {
                loadScope(scope.scopes[x], indent + 1, scope.name);
            }
        }

        function initTree() {
            $('#jstree')
                .on('changed.jstree', function(e, data) {
                    console.log(data.node.original.wires);
                    $('#debug').html(data.node.original.wires);
                })
                .jstree({
                    'core': {
                        'data': treeScope
                    }
                });
        }

        function loadData(data) {
            if (data == null) {
                return;
            }
            let lastValue = {};

            for (let x = 0; x < data.length; x++) {
                let d = data[x];
                if (d.left[0] == '#') {
                    if (x > 0) {
                        for (let [reference, value] of Object.entries(wiresValue)) {
                            wiresValues[reference].push(value);

                            let tempValue = value;
                            if (wireSize[reference] > 0) {
                                tempValue = parseInt(value, 2);
                            }
                            let change = '';
                            let width = '100%';
                            if (lastValue[reference] == null) {
                                lastValue[reference] = 0;
                            } else {
                                if ((tempValue > 0 ? 1 : 0) != lastValue[reference]) {
                                    change = '<img src="{basePath}/../../resources/dark/change.svg" style="stroke:rgb(255,255,0);" width="2px" height="40px" />';
                                    width = '10px';
                                }
                            }
                            for (let x = 0; x < referenceToWireRowId[reference].length; x++) {
                                let id = referenceToWireRowId[reference][x];
                                if (tempValue == 0) {
                                    img = "low.svg";
                                } else {
                                    img = "high.svg";
                                }
                                // $('#mainTable').find('tr#' + id).find('td:last').after('<td class="wireTd">' + change + '<img src="{basePath}/../../resources/dark/' + img + '" style="stroke:rgb(255,255,0);" width="' + width + '" height="40px" />' + tempValue + '</td>');
                                $('#mainTable').find('tr#' + id).find('td:last').after('<td class="wireTd"><img src="{basePath}/../../resources/dark/' + img + '" style="fill:rgb(255,255,0);stroke:rgb(255,255,0);" width="' + width + '" height="40px" />' + tempValue + '</td>');
                            }
                            lastValue[reference] = (tempValue > 0 ? 1 : 0);
                        }
                    }
                } else {
                    if (d.right != null) {
                        reference = d.right;
                        if (d.left[0] == 'b') {
                            value = d.left.substring(1);
                        } else {
                            value = d.left;
                        }
                    } else {
                        reference = d.left[1];
                        value = d.left[0];
                    }
                    for (let x = 0; x < referenceToWireRowId[reference].length; x++) {
                        wiresValue[reference] = value;
                    }
                    // console.log(reference + ' <= ' + value);
                }
            }
        }
    </script>
    <script>
        var width = window.innerWidth;
        var height;
        var stage;
        var wireWidth = 200;
        var wireHeight = 40;
        var wireBackground = "#333";
        var wireStoke = "#777";
        var wireNameColor = "white";
        var wireLowColor = "yellow";
        var wireHighColor = "yellow";
        var valueBlockWidth;

        function initKonva() {
            valueBlockWidth = $('#blockWidth').val();

            height = Object.entries(wires).length * 80;
            stage = new Konva.Stage({
                container: 'container',
                width: width,
                height: height,
            });

            //initGrid();
            initWires();
        }

        function initGrid() {
            var blockSnapWidth = wireHeight;
            var blockSnapHeight = wireHeight;
            var gridLayer = new Konva.Layer();
            var paddingWidth = blockSnapWidth;
            var paddingHeight = blockSnapHeight;
            for (var i = 0; i < width / paddingWidth; i++) {
                gridLayer.add(new Konva.Line({
                    points: [Math.round(i * paddingWidth) + 0.5, 0, Math.round(i * paddingWidth) + 0.5, height],
                    stroke: '#666',
                    strokeWidth: 1,
                }));
            }
            for (var j = 0; j <= height / paddingHeight; j++) {
                gridLayer.add(new Konva.Line({
                    points: [0, Math.round(j * paddingHeight), width, Math.round(j * paddingHeight)],
                    stroke: '#666',
                    strokeWidth: 0.5,
                }));
            }
            stage.add(gridLayer);
        }

        function initWires() {
            var wireLayer = new Konva.Layer();
            let y = 0;
            for (let [name, wire] of Object.entries(wires)) {
                console.log('initWires ' + new Date() + ' ' + name);
                let offsetY = y * wireHeight;

                var wireRect = new Konva.Rect({
                    x: 0,
                    y: offsetY,
                    width: wireWidth,
                    height: wireHeight,
                    fill: wireBackground,
                    opacity: 0.6,
                    stroke: wireStoke,
                    strokeWidth: 1,
                });
                wireLayer.add(wireRect);

                var text = new Konva.Text({
                    x: 90,
                    y: offsetY + 15,
                    text: name,
                    fontSize: 14,
                    fontFamily: 'arial',
                    fill: wireNameColor
                });
                wireLayer.add(text);

                Konva.Image.fromURL('{basePath}/../../resources/dark/cpu2.svg', (image) => {
                    wireLayer.add(image);
                    image.setAttrs({
                        x: 10,
                        y: offsetY + 10,
                        width: 30,
                        height: 30,
                    });
                    wireLayer.batchDraw();
                });
                y++;

                // init data
                let data = wiresValues[wiresNameToReference[name]];
                data.forEach(function(item, index, array) {
                    var wireRect = new Konva.Rect({
                        x: index * valueBlockWidth + wireWidth,
                        y: offsetY,
                        width: valueBlockWidth,
                        height: wireHeight,
                        fill: wireBackground,
                        opacity: 0.6,
                        stroke: wireStoke,
                        strokeWidth: 1,
                    });
                    wireLayer.add(wireRect);

                    var tempValue;
                    if (wireSize[wiresNameToReference[name]] > 0) {
                        tempValue = parseInt(item, 2);
                    } else {
                        tempValue = item;
                    }
                    if (tempValue == 0) {
                        var lowRect = new Konva.Rect({
                            x: index * valueBlockWidth + wireWidth,
                            y: offsetY + wireHeight - 10 - 20,
                            width: valueBlockWidth,
                            height: 10,
                            fill: wireLowColor,
                            opacity: 1,
                            stroke: wireStoke,
                            strokeWidth: 1,
                        });
                        wireLayer.add(lowRect);
                    } else {
                        var highRect = new Konva.Rect({
                            x: index * valueBlockWidth + wireWidth,
                            y: offsetY + 10,
                            width: valueBlockWidth,
                            height: wireHeight - 10 - 20,
                            fill: wireHighColor,
                            opacity: 1,
                            stroke: wireStoke,
                            strokeWidth: 1,
                        });
                        wireLayer.add(highRect);
                    }

                    var text = new Konva.Text({
                        x: index * valueBlockWidth + wireWidth,
                        y: offsetY + wireHeight - 15,
                        width: valueBlockWidth,
                        text: tempValue,
                        fontSize: 12,
                        fontFamily: 'arial',
                        fill: wireNameColor
                    });
                    text.align('center');
                    wireLayer.add(text);
                });
            }
            stage.add(wireLayer);

            console.log('end initWires ' + new Date());
        }
    </script>
    <script>
        const vscode = acquireVsCodeApi();
    </script>
</body>

</html>